import{S as oi,i as ri,s as ai,e as r,k as f,w as d,t as h,M as si,c as a,d as t,m as p,a as s,x as m,h as u,b as l,N as Gt,G as o,g as n,y as v,q as w,o as g,B as y,v as ii}from"../../chunks/vendor-hf-doc-builder.js";import{T as ni}from"../../chunks/Tip-hf-doc-builder.js";import{I as k}from"../../chunks/IconCopyLink-hf-doc-builder.js";function li(Bt){let c;return{c(){c=h("\u{1F4A1} If you take an existing waveform and apply the Short-Time Fourier Transform or STFT, it is possible to perform the inverse operation, the ISTFT, to get the original waveform again. This works because the spectrogram created by the STFT contains both amplitude and phase information, and both are needed to reconstruct the waveform. However, audio models that generate their output as a spectrogram typically only predict the amplitude information, not the phase. To turn such a spectrogram into a waveform, we have to somehow estimate the phase information. That's what a vocoder does.")},l(E){c=u(E,"\u{1F4A1} If you take an existing waveform and apply the Short-Time Fourier Transform or STFT, it is possible to perform the inverse operation, the ISTFT, to get the original waveform again. This works because the spectrogram created by the STFT contains both amplitude and phase information, and both are needed to reconstruct the waveform. However, audio models that generate their output as a spectrogram typically only predict the amplitude information, not the phase. To turn such a spectrogram into a waveform, we have to somehow estimate the phase information. That's what a vocoder does.")},m(E,T){n(E,c,T)},d(E){E&&t(c)}}}function hi(Bt){let c,E,T,L,Je,ae,Ko,Ke,Qo,Ct,W,Xo,se,Zo,er,zt,S,G,Qe,ie,tr,Xe,or,Vt,Te,rr,jt,ne,Ee,Ta,Ut,$,ar,Ze,sr,ir,et,nr,lr,Dt,B,tt,ot,hr,ur,rt,at,fr,Yt,$e,pr,Jt,C,cr,st,dr,mr,Kt,A,z,it,le,vr,nt,wr,Qt,xe,gr,Xt,he,Se,Ea,Zt,Ae,yr,eo,b,lt,ht,br,_r,ut,ft,kr,Tr,pt,ct,Er,$r,dt,mt,xr,to,qe,Sr,oo,q,V,vt,ue,Ar,wt,qr,ro,Pe,Pr,ao,P,j,gt,fe,Nr,yt,Ir,so,Ne,Hr,io,N,U,bt,pe,Mr,_t,Or,no,Ie,Rr,lo,_,Fr,kt,Lr,Wr,Tt,Gr,Br,He,Cr,zr,ho,ce,Me,$a,uo,Oe,Vr,fo,I,D,Et,de,jr,$t,Ur,po,Y,Dr,xt,Yr,Jr,co,Re,Kr,mo,me,Fe,xa,vo,x,Qr,St,Xr,Zr,At,ea,ta,wo,Le,oa,go,H,J,qt,ve,ra,Pt,aa,yo,We,sa,bo,M,K,Nt,we,ia,It,na,_o,Ge,la,ko,O,Q,Ht,ge,ha,Mt,ua,To,Be,fa,Eo,X,pa,Ot,ca,da,$o,ye,Ce,Sa,xo,Z,So,R,ee,Rt,be,ma,Ft,va,Ao,ze,wa,qo,F,te,Lt,_e,ga,Wt,ya,Po,Ve,ba,No,je,_a,Io,Ue,ka,Ho;return ae=new k({}),ie=new k({}),le=new k({}),ue=new k({}),fe=new k({}),pe=new k({}),de=new k({}),ve=new k({}),we=new k({}),ge=new k({}),Z=new ni({props:{$$slots:{default:[li]},$$scope:{ctx:Bt}}}),be=new k({}),_e=new k({}),{c(){c=r("meta"),E=f(),T=r("h1"),L=r("a"),Je=r("span"),d(ae.$$.fragment),Ko=f(),Ke=r("span"),Qo=h("Unit 3. Transformer architectures for audio"),Ct=f(),W=r("p"),Xo=h("In this course we will primarily consider transformer models and how they can be applied to audio tasks. While you don\u2019t need to know the inner details of these models, it\u2019s useful to understand the main concepts that make them work, so here\u2019s a quick refresher. For a deep dive into transformers, check out our "),se=r("a"),Zo=h("NLP Course"),er=h("."),zt=f(),S=r("h2"),G=r("a"),Qe=r("span"),d(ie.$$.fragment),tr=f(),Xe=r("span"),or=h("How does a transformer work?"),Vt=f(),Te=r("p"),rr=h("The original transformer model was designed to translate written text from one language into another. Its architecture looked like this:"),jt=f(),ne=r("div"),Ee=r("img"),Ut=f(),$=r("p"),ar=h("On the left is the "),Ze=r("strong"),sr=h("encoder"),ir=h(" and on the right is the "),et=r("strong"),nr=h("decoder"),lr=h("."),Dt=f(),B=r("ul"),tt=r("li"),ot=r("p"),hr=h("The encoder receives an input, in this case a sequence of text tokens, and builds a representation of it (its features). This part of the model is trained to acquire understanding from the input."),ur=f(),rt=r("li"),at=r("p"),fr=h("The decoder uses the encoder\u2019s representation (the features) along with other inputs (the previously predicted tokens) to generate a target sequence. This part of the model is trained to generate outputs. In the original design, the output sequence consisted of text tokens."),Yt=f(),$e=r("p"),pr=h("There are also transformer-based models that only use the encoder part (good for tasks that require understanding of the input, such as classification), or only the decoder part (good for tasks such as text generation). An example of an encoder-only model is BERT; an example of a decoder-only model is GPT2."),Jt=f(),C=r("p"),cr=h("A key feature of transformer models is that they are built with special layers called "),st=r("strong"),dr=h("attention layers"),mr=h(". These layers tell the model to pay specific attention to certain elements in the input sequence and ignore others when computing the feature representations."),Kt=f(),A=r("h2"),z=r("a"),it=r("span"),d(le.$$.fragment),vr=f(),nt=r("span"),wr=h("Using transformers for audio"),Qt=f(),xe=r("p"),gr=h("The audio models we\u2019ll cover in this course typically have a standard transformer architecture as shown above, but with a slight modification on the input or output side to allow for audio data instead of text. Since all these models are transformers at heart, they will have most of their architecture in common and the main differences are in how they are trained and used."),Xt=f(),he=r("div"),Se=r("img"),Zt=f(),Ae=r("p"),yr=h("For audio tasks, the input and/or output sequences may be audio instead of text:"),eo=f(),b=r("ul"),lt=r("li"),ht=r("p"),br=h("Automatic speech recognition (ASR): The input is speech, the output is text."),_r=f(),ut=r("li"),ft=r("p"),kr=h("Speech synthesis (TTS): The input is text, the output is speech."),Tr=f(),pt=r("li"),ct=r("p"),Er=h("Audio classification: The input is audio, the output is a class probability \u2014 one for each element in the sequence or a single class probability for the entire sequence."),$r=f(),dt=r("li"),mt=r("p"),xr=h("Voice conversion or speech enhancement: Both the input and output are audio."),to=f(),qe=r("p"),Sr=h("There are a few different ways to handle audio so it can be used with a transformer. The main consideration is whether to use the audio in its raw form \u2014 as a waveform \u2014 or to process it as a spectrogram instead."),oo=f(),q=r("h2"),V=r("a"),vt=r("span"),d(ue.$$.fragment),Ar=f(),wt=r("span"),qr=h("Model inputs"),ro=f(),Pe=r("p"),Pr=h("The input to an audio model can be either text or sound. The goal is to convert this input into an embedding vector that can be processed by the transformer architecture."),ao=f(),P=r("h3"),j=r("a"),gt=r("span"),d(fe.$$.fragment),Nr=f(),yt=r("span"),Ir=h("Text input"),so=f(),Ne=r("p"),Hr=h("A text-to-speech model takes text as input. This works just like the original transformer or any other NLP model: The input text is first tokenized, giving a sequence of text tokens. This sequence is sent through an input embedding layer to convert the tokens into 512-dimensional vectors. Those embedding vectors are then passed into the transformer encoder."),io=f(),N=r("h3"),U=r("a"),bt=r("span"),d(pe.$$.fragment),Mr=f(),_t=r("span"),Or=h("Waveform input"),no=f(),Ie=r("p"),Rr=h("An automatic speech recognition model takes audio as input. To be able to use a transformer for ASR, we first need to convert the audio into a sequence of embedding vectors somehow."),lo=f(),_=r("p"),Fr=h("Models such as "),kt=r("strong"),Lr=h("Wav2Vec2"),Wr=h(" and "),Tt=r("strong"),Gr=h("HuBERT"),Br=h(" use the audio waveform directly as the input to the model. As you\u2019ve seen in "),He=r("a"),Cr=h("the chapter on audio data"),zr=h(", a waveform is a one-dimensional sequence of floating-point numbers, where each number represents the sampled amplitude at a given time. This raw waveform is first normalized to zero mean and unit variance, which helps to standardize audio samples across different volumes (amplitudes)."),ho=f(),ce=r("div"),Me=r("img"),uo=f(),Oe=r("p"),Vr=h("After normalizing, the sequence of audio samples is turned into an embedding using a small convolutional neural network, known as the feature encoder. Each of the convolutional layers in this network processes the input sequence, subsampling the audio to reduce the sequence length, until the final convolutional layer outputs a 512-dimensional vector with the embedding for each 25 ms of audio. Once the input sequence has been transformed into a sequence of such embeddings, the transformer will process the data as usual."),fo=f(),I=r("h3"),D=r("a"),Et=r("span"),d(de.$$.fragment),jr=f(),$t=r("span"),Ur=h("Spectrogram input"),po=f(),Y=r("p"),Dr=h("One downside of using the raw waveform as input is that they tend to have long sequence lengths. For example, thirty seconds of audio at a sampling rate of 16 kHz gives an input of length "),xt=r("code"),Yr=h("30 * 16000 = 480000"),Jr=h(". Longer sequence lengths require more computations in the transformer model, and so higher memory usage."),co=f(),Re=r("p"),Kr=h("Because of this, raw audio waveforms are not usually the most efficient form of representing an audio input. By using a spectrogram, we get the same amount of information but in a more compressed form."),mo=f(),me=r("div"),Fe=r("img"),vo=f(),x=r("p"),Qr=h("Models such as "),St=r("strong"),Xr=h("Whisper"),Zr=h(" first convert the waveform into a log-mel spectrogram. Whisper always splits the audio into 30-second segments, and the log-mel spectrogram for each segment has shape "),At=r("code"),ea=h("(80, 3000)"),ta=h(" where 80 is the number of mel bins and 3000 is the sequence length. By converting to a log-mel spectrogram we\u2019ve reduced the amount of input data, but more importantly, this is a much shorter sequence than the raw waveform. The log-mel spectrogram is then processed by a small CNN into a sequence of embeddings, which goes into the transformer as usual."),wo=f(),Le=r("p"),oa=h("In both cases, waveform as well as spectrogram input, there is a small network in front of the transformer that converts the input into embeddings and then the transformer takes over to do its thing."),go=f(),H=r("h2"),J=r("a"),qt=r("span"),d(ve.$$.fragment),ra=f(),Pt=r("span"),aa=h("Model outputs"),yo=f(),We=r("p"),sa=h("The transformer architecture outputs a sequence of hidden-state vectors, also known as the output embeddings. Our goal is to transform these vectors into a text or audio output."),bo=f(),M=r("h3"),K=r("a"),Nt=r("span"),d(we.$$.fragment),ia=f(),It=r("span"),na=h("Text output"),_o=f(),Ge=r("p"),la=h("The goal of an automatic speech recognition model is to predict a sequence of text tokens. This is done by adding a language modeling head \u2014 typically a single linear layer \u2014 followed by a softmax on top of the transformer\u2019s output. This predicts the probabilities over the text tokens in the vocabulary."),ko=f(),O=r("h3"),Q=r("a"),Ht=r("span"),d(ge.$$.fragment),ha=f(),Mt=r("span"),ua=h("Spectrogram output"),To=f(),Be=r("p"),fa=h("For models that generate audio, such as a text-to-speech (TTS) model, we\u2019ll have to add layers that can produce an audio sequence. It\u2019s very common to generate a spectrogram and then use an additional neural network, known as a vocoder, to turn this spectrogram into a waveform."),Eo=f(),X=r("p"),pa=h("In the "),Ot=r("strong"),ca=h("SpeechT5"),da=h(" TTS model, for example, the output from the transformer network is a sequence of 768-element vectors. A linear layer projects that sequence into a log-mel spectrogram. A so-called post-net, made up of additional linear and convolutional layers, refines the spectrogram by reducing noise. The vocoder then makes the final audio waveform."),$o=f(),ye=r("div"),Ce=r("img"),xo=f(),d(Z.$$.fragment),So=f(),R=r("h3"),ee=r("a"),Rt=r("span"),d(be.$$.fragment),ma=f(),Ft=r("span"),va=h("Waveform output"),Ao=f(),ze=r("p"),wa=h("It\u2019s also possible for models to directly output a waveform instead of a spectrogram as an intermediate step, but we currently don\u2019t have any models in \u{1F917} Transformers that do this."),qo=f(),F=r("h2"),te=r("a"),Lt=r("span"),d(_e.$$.fragment),ga=f(),Wt=r("span"),ya=h("Conclusion"),Po=f(),Ve=r("p"),ba=h("In summary: Most audio transformer models are more alike than different \u2014 they\u2019re all built on the same transformer architecture and attention layers, although some models will only use the encoder portion of the transformer while others use both the encoder and decoder."),No=f(),je=r("p"),_a=h("You\u2019ve also seen how to get audio data into and out of transformer models. To perform the different audio tasks of ASR, TTS, and so on, we can simply swap out the layers that pre-process the inputs into embeddings, and swap out the layers that post-process the predicted embeddings into outputs, while the transformer backbone stays the same."),Io=f(),Ue=r("p"),ka=h("Next, let\u2019s look at a few different ways these models can be trained to do automatic speech recognition."),this.h()},l(e){const i=si('[data-svelte="svelte-1phssyn"]',document.head);c=a(i,"META",{name:!0,content:!0}),i.forEach(t),E=p(e),T=a(e,"H1",{class:!0});var ke=s(T);L=a(ke,"A",{id:!0,class:!0,href:!0});var Aa=s(L);Je=a(Aa,"SPAN",{});var qa=s(Je);m(ae.$$.fragment,qa),qa.forEach(t),Aa.forEach(t),Ko=p(ke),Ke=a(ke,"SPAN",{});var Pa=s(Ke);Qo=u(Pa,"Unit 3. Transformer architectures for audio"),Pa.forEach(t),ke.forEach(t),Ct=p(e),W=a(e,"P",{});var Mo=s(W);Xo=u(Mo,"In this course we will primarily consider transformer models and how they can be applied to audio tasks. While you don\u2019t need to know the inner details of these models, it\u2019s useful to understand the main concepts that make them work, so here\u2019s a quick refresher. For a deep dive into transformers, check out our "),se=a(Mo,"A",{href:!0,rel:!0});var Na=s(se);Zo=u(Na,"NLP Course"),Na.forEach(t),er=u(Mo,"."),Mo.forEach(t),zt=p(e),S=a(e,"H2",{class:!0});var Oo=s(S);G=a(Oo,"A",{id:!0,class:!0,href:!0});var Ia=s(G);Qe=a(Ia,"SPAN",{});var Ha=s(Qe);m(ie.$$.fragment,Ha),Ha.forEach(t),Ia.forEach(t),tr=p(Oo),Xe=a(Oo,"SPAN",{});var Ma=s(Xe);or=u(Ma,"How does a transformer work?"),Ma.forEach(t),Oo.forEach(t),Vt=p(e),Te=a(e,"P",{});var Oa=s(Te);rr=u(Oa,"The original transformer model was designed to translate written text from one language into another. Its architecture looked like this:"),Oa.forEach(t),jt=p(e),ne=a(e,"DIV",{class:!0});var Ra=s(ne);Ee=a(Ra,"IMG",{src:!0,alt:!0}),Ra.forEach(t),Ut=p(e),$=a(e,"P",{});var De=s($);ar=u(De,"On the left is the "),Ze=a(De,"STRONG",{});var Fa=s(Ze);sr=u(Fa,"encoder"),Fa.forEach(t),ir=u(De," and on the right is the "),et=a(De,"STRONG",{});var La=s(et);nr=u(La,"decoder"),La.forEach(t),lr=u(De,"."),De.forEach(t),Dt=p(e),B=a(e,"UL",{});var Ro=s(B);tt=a(Ro,"LI",{});var Wa=s(tt);ot=a(Wa,"P",{});var Ga=s(ot);hr=u(Ga,"The encoder receives an input, in this case a sequence of text tokens, and builds a representation of it (its features). This part of the model is trained to acquire understanding from the input."),Ga.forEach(t),Wa.forEach(t),ur=p(Ro),rt=a(Ro,"LI",{});var Ba=s(rt);at=a(Ba,"P",{});var Ca=s(at);fr=u(Ca,"The decoder uses the encoder\u2019s representation (the features) along with other inputs (the previously predicted tokens) to generate a target sequence. This part of the model is trained to generate outputs. In the original design, the output sequence consisted of text tokens."),Ca.forEach(t),Ba.forEach(t),Ro.forEach(t),Yt=p(e),$e=a(e,"P",{});var za=s($e);pr=u(za,"There are also transformer-based models that only use the encoder part (good for tasks that require understanding of the input, such as classification), or only the decoder part (good for tasks such as text generation). An example of an encoder-only model is BERT; an example of a decoder-only model is GPT2."),za.forEach(t),Jt=p(e),C=a(e,"P",{});var Fo=s(C);cr=u(Fo,"A key feature of transformer models is that they are built with special layers called "),st=a(Fo,"STRONG",{});var Va=s(st);dr=u(Va,"attention layers"),Va.forEach(t),mr=u(Fo,". These layers tell the model to pay specific attention to certain elements in the input sequence and ignore others when computing the feature representations."),Fo.forEach(t),Kt=p(e),A=a(e,"H2",{class:!0});var Lo=s(A);z=a(Lo,"A",{id:!0,class:!0,href:!0});var ja=s(z);it=a(ja,"SPAN",{});var Ua=s(it);m(le.$$.fragment,Ua),Ua.forEach(t),ja.forEach(t),vr=p(Lo),nt=a(Lo,"SPAN",{});var Da=s(nt);wr=u(Da,"Using transformers for audio"),Da.forEach(t),Lo.forEach(t),Qt=p(e),xe=a(e,"P",{});var Ya=s(xe);gr=u(Ya,"The audio models we\u2019ll cover in this course typically have a standard transformer architecture as shown above, but with a slight modification on the input or output side to allow for audio data instead of text. Since all these models are transformers at heart, they will have most of their architecture in common and the main differences are in how they are trained and used."),Ya.forEach(t),Xt=p(e),he=a(e,"DIV",{class:!0});var Ja=s(he);Se=a(Ja,"IMG",{src:!0,alt:!0}),Ja.forEach(t),Zt=p(e),Ae=a(e,"P",{});var Ka=s(Ae);yr=u(Ka,"For audio tasks, the input and/or output sequences may be audio instead of text:"),Ka.forEach(t),eo=p(e),b=a(e,"UL",{});var oe=s(b);lt=a(oe,"LI",{});var Qa=s(lt);ht=a(Qa,"P",{});var Xa=s(ht);br=u(Xa,"Automatic speech recognition (ASR): The input is speech, the output is text."),Xa.forEach(t),Qa.forEach(t),_r=p(oe),ut=a(oe,"LI",{});var Za=s(ut);ft=a(Za,"P",{});var es=s(ft);kr=u(es,"Speech synthesis (TTS): The input is text, the output is speech."),es.forEach(t),Za.forEach(t),Tr=p(oe),pt=a(oe,"LI",{});var ts=s(pt);ct=a(ts,"P",{});var os=s(ct);Er=u(os,"Audio classification: The input is audio, the output is a class probability \u2014 one for each element in the sequence or a single class probability for the entire sequence."),os.forEach(t),ts.forEach(t),$r=p(oe),dt=a(oe,"LI",{});var rs=s(dt);mt=a(rs,"P",{});var as=s(mt);xr=u(as,"Voice conversion or speech enhancement: Both the input and output are audio."),as.forEach(t),rs.forEach(t),oe.forEach(t),to=p(e),qe=a(e,"P",{});var ss=s(qe);Sr=u(ss,"There are a few different ways to handle audio so it can be used with a transformer. The main consideration is whether to use the audio in its raw form \u2014 as a waveform \u2014 or to process it as a spectrogram instead."),ss.forEach(t),oo=p(e),q=a(e,"H2",{class:!0});var Wo=s(q);V=a(Wo,"A",{id:!0,class:!0,href:!0});var is=s(V);vt=a(is,"SPAN",{});var ns=s(vt);m(ue.$$.fragment,ns),ns.forEach(t),is.forEach(t),Ar=p(Wo),wt=a(Wo,"SPAN",{});var ls=s(wt);qr=u(ls,"Model inputs"),ls.forEach(t),Wo.forEach(t),ro=p(e),Pe=a(e,"P",{});var hs=s(Pe);Pr=u(hs,"The input to an audio model can be either text or sound. The goal is to convert this input into an embedding vector that can be processed by the transformer architecture."),hs.forEach(t),ao=p(e),P=a(e,"H3",{class:!0});var Go=s(P);j=a(Go,"A",{id:!0,class:!0,href:!0});var us=s(j);gt=a(us,"SPAN",{});var fs=s(gt);m(fe.$$.fragment,fs),fs.forEach(t),us.forEach(t),Nr=p(Go),yt=a(Go,"SPAN",{});var ps=s(yt);Ir=u(ps,"Text input"),ps.forEach(t),Go.forEach(t),so=p(e),Ne=a(e,"P",{});var cs=s(Ne);Hr=u(cs,"A text-to-speech model takes text as input. This works just like the original transformer or any other NLP model: The input text is first tokenized, giving a sequence of text tokens. This sequence is sent through an input embedding layer to convert the tokens into 512-dimensional vectors. Those embedding vectors are then passed into the transformer encoder."),cs.forEach(t),io=p(e),N=a(e,"H3",{class:!0});var Bo=s(N);U=a(Bo,"A",{id:!0,class:!0,href:!0});var ds=s(U);bt=a(ds,"SPAN",{});var ms=s(bt);m(pe.$$.fragment,ms),ms.forEach(t),ds.forEach(t),Mr=p(Bo),_t=a(Bo,"SPAN",{});var vs=s(_t);Or=u(vs,"Waveform input"),vs.forEach(t),Bo.forEach(t),no=p(e),Ie=a(e,"P",{});var ws=s(Ie);Rr=u(ws,"An automatic speech recognition model takes audio as input. To be able to use a transformer for ASR, we first need to convert the audio into a sequence of embedding vectors somehow."),ws.forEach(t),lo=p(e),_=a(e,"P",{});var re=s(_);Fr=u(re,"Models such as "),kt=a(re,"STRONG",{});var gs=s(kt);Lr=u(gs,"Wav2Vec2"),gs.forEach(t),Wr=u(re," and "),Tt=a(re,"STRONG",{});var ys=s(Tt);Gr=u(ys,"HuBERT"),ys.forEach(t),Br=u(re," use the audio waveform directly as the input to the model. As you\u2019ve seen in "),He=a(re,"A",{href:!0});var bs=s(He);Cr=u(bs,"the chapter on audio data"),bs.forEach(t),zr=u(re,", a waveform is a one-dimensional sequence of floating-point numbers, where each number represents the sampled amplitude at a given time. This raw waveform is first normalized to zero mean and unit variance, which helps to standardize audio samples across different volumes (amplitudes)."),re.forEach(t),ho=p(e),ce=a(e,"DIV",{class:!0});var _s=s(ce);Me=a(_s,"IMG",{src:!0,alt:!0}),_s.forEach(t),uo=p(e),Oe=a(e,"P",{});var ks=s(Oe);Vr=u(ks,"After normalizing, the sequence of audio samples is turned into an embedding using a small convolutional neural network, known as the feature encoder. Each of the convolutional layers in this network processes the input sequence, subsampling the audio to reduce the sequence length, until the final convolutional layer outputs a 512-dimensional vector with the embedding for each 25 ms of audio. Once the input sequence has been transformed into a sequence of such embeddings, the transformer will process the data as usual."),ks.forEach(t),fo=p(e),I=a(e,"H3",{class:!0});var Co=s(I);D=a(Co,"A",{id:!0,class:!0,href:!0});var Ts=s(D);Et=a(Ts,"SPAN",{});var Es=s(Et);m(de.$$.fragment,Es),Es.forEach(t),Ts.forEach(t),jr=p(Co),$t=a(Co,"SPAN",{});var $s=s($t);Ur=u($s,"Spectrogram input"),$s.forEach(t),Co.forEach(t),po=p(e),Y=a(e,"P",{});var zo=s(Y);Dr=u(zo,"One downside of using the raw waveform as input is that they tend to have long sequence lengths. For example, thirty seconds of audio at a sampling rate of 16 kHz gives an input of length "),xt=a(zo,"CODE",{});var xs=s(xt);Yr=u(xs,"30 * 16000 = 480000"),xs.forEach(t),Jr=u(zo,". Longer sequence lengths require more computations in the transformer model, and so higher memory usage."),zo.forEach(t),co=p(e),Re=a(e,"P",{});var Ss=s(Re);Kr=u(Ss,"Because of this, raw audio waveforms are not usually the most efficient form of representing an audio input. By using a spectrogram, we get the same amount of information but in a more compressed form."),Ss.forEach(t),mo=p(e),me=a(e,"DIV",{class:!0});var As=s(me);Fe=a(As,"IMG",{src:!0,alt:!0}),As.forEach(t),vo=p(e),x=a(e,"P",{});var Ye=s(x);Qr=u(Ye,"Models such as "),St=a(Ye,"STRONG",{});var qs=s(St);Xr=u(qs,"Whisper"),qs.forEach(t),Zr=u(Ye," first convert the waveform into a log-mel spectrogram. Whisper always splits the audio into 30-second segments, and the log-mel spectrogram for each segment has shape "),At=a(Ye,"CODE",{});var Ps=s(At);ea=u(Ps,"(80, 3000)"),Ps.forEach(t),ta=u(Ye," where 80 is the number of mel bins and 3000 is the sequence length. By converting to a log-mel spectrogram we\u2019ve reduced the amount of input data, but more importantly, this is a much shorter sequence than the raw waveform. The log-mel spectrogram is then processed by a small CNN into a sequence of embeddings, which goes into the transformer as usual."),Ye.forEach(t),wo=p(e),Le=a(e,"P",{});var Ns=s(Le);oa=u(Ns,"In both cases, waveform as well as spectrogram input, there is a small network in front of the transformer that converts the input into embeddings and then the transformer takes over to do its thing."),Ns.forEach(t),go=p(e),H=a(e,"H2",{class:!0});var Vo=s(H);J=a(Vo,"A",{id:!0,class:!0,href:!0});var Is=s(J);qt=a(Is,"SPAN",{});var Hs=s(qt);m(ve.$$.fragment,Hs),Hs.forEach(t),Is.forEach(t),ra=p(Vo),Pt=a(Vo,"SPAN",{});var Ms=s(Pt);aa=u(Ms,"Model outputs"),Ms.forEach(t),Vo.forEach(t),yo=p(e),We=a(e,"P",{});var Os=s(We);sa=u(Os,"The transformer architecture outputs a sequence of hidden-state vectors, also known as the output embeddings. Our goal is to transform these vectors into a text or audio output."),Os.forEach(t),bo=p(e),M=a(e,"H3",{class:!0});var jo=s(M);K=a(jo,"A",{id:!0,class:!0,href:!0});var Rs=s(K);Nt=a(Rs,"SPAN",{});var Fs=s(Nt);m(we.$$.fragment,Fs),Fs.forEach(t),Rs.forEach(t),ia=p(jo),It=a(jo,"SPAN",{});var Ls=s(It);na=u(Ls,"Text output"),Ls.forEach(t),jo.forEach(t),_o=p(e),Ge=a(e,"P",{});var Ws=s(Ge);la=u(Ws,"The goal of an automatic speech recognition model is to predict a sequence of text tokens. This is done by adding a language modeling head \u2014 typically a single linear layer \u2014 followed by a softmax on top of the transformer\u2019s output. This predicts the probabilities over the text tokens in the vocabulary."),Ws.forEach(t),ko=p(e),O=a(e,"H3",{class:!0});var Uo=s(O);Q=a(Uo,"A",{id:!0,class:!0,href:!0});var Gs=s(Q);Ht=a(Gs,"SPAN",{});var Bs=s(Ht);m(ge.$$.fragment,Bs),Bs.forEach(t),Gs.forEach(t),ha=p(Uo),Mt=a(Uo,"SPAN",{});var Cs=s(Mt);ua=u(Cs,"Spectrogram output"),Cs.forEach(t),Uo.forEach(t),To=p(e),Be=a(e,"P",{});var zs=s(Be);fa=u(zs,"For models that generate audio, such as a text-to-speech (TTS) model, we\u2019ll have to add layers that can produce an audio sequence. It\u2019s very common to generate a spectrogram and then use an additional neural network, known as a vocoder, to turn this spectrogram into a waveform."),zs.forEach(t),Eo=p(e),X=a(e,"P",{});var Do=s(X);pa=u(Do,"In the "),Ot=a(Do,"STRONG",{});var Vs=s(Ot);ca=u(Vs,"SpeechT5"),Vs.forEach(t),da=u(Do," TTS model, for example, the output from the transformer network is a sequence of 768-element vectors. A linear layer projects that sequence into a log-mel spectrogram. A so-called post-net, made up of additional linear and convolutional layers, refines the spectrogram by reducing noise. The vocoder then makes the final audio waveform."),Do.forEach(t),$o=p(e),ye=a(e,"DIV",{class:!0});var js=s(ye);Ce=a(js,"IMG",{src:!0,alt:!0}),js.forEach(t),xo=p(e),m(Z.$$.fragment,e),So=p(e),R=a(e,"H3",{class:!0});var Yo=s(R);ee=a(Yo,"A",{id:!0,class:!0,href:!0});var Us=s(ee);Rt=a(Us,"SPAN",{});var Ds=s(Rt);m(be.$$.fragment,Ds),Ds.forEach(t),Us.forEach(t),ma=p(Yo),Ft=a(Yo,"SPAN",{});var Ys=s(Ft);va=u(Ys,"Waveform output"),Ys.forEach(t),Yo.forEach(t),Ao=p(e),ze=a(e,"P",{});var Js=s(ze);wa=u(Js,"It\u2019s also possible for models to directly output a waveform instead of a spectrogram as an intermediate step, but we currently don\u2019t have any models in \u{1F917} Transformers that do this."),Js.forEach(t),qo=p(e),F=a(e,"H2",{class:!0});var Jo=s(F);te=a(Jo,"A",{id:!0,class:!0,href:!0});var Ks=s(te);Lt=a(Ks,"SPAN",{});var Qs=s(Lt);m(_e.$$.fragment,Qs),Qs.forEach(t),Ks.forEach(t),ga=p(Jo),Wt=a(Jo,"SPAN",{});var Xs=s(Wt);ya=u(Xs,"Conclusion"),Xs.forEach(t),Jo.forEach(t),Po=p(e),Ve=a(e,"P",{});var Zs=s(Ve);ba=u(Zs,"In summary: Most audio transformer models are more alike than different \u2014 they\u2019re all built on the same transformer architecture and attention layers, although some models will only use the encoder portion of the transformer while others use both the encoder and decoder."),Zs.forEach(t),No=p(e),je=a(e,"P",{});var ei=s(je);_a=u(ei,"You\u2019ve also seen how to get audio data into and out of transformer models. To perform the different audio tasks of ASR, TTS, and so on, we can simply swap out the layers that pre-process the inputs into embeddings, and swap out the layers that post-process the predicted embeddings into outputs, while the transformer backbone stays the same."),ei.forEach(t),Io=p(e),Ue=a(e,"P",{});var ti=s(Ue);ka=u(ti,"Next, let\u2019s look at a few different ways these models can be trained to do automatic speech recognition."),ti.forEach(t),this.h()},h(){l(c,"name","hf:doc:metadata"),l(c,"content",JSON.stringify(ui)),l(L,"id","unit-3-transformer-architectures-for-audio"),l(L,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(L,"href","#unit-3-transformer-architectures-for-audio"),l(T,"class","relative group"),l(se,"href","https://huggingface.co/course/chapter1/1"),l(se,"rel","nofollow"),l(G,"id","how-does-a-transformer-work"),l(G,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(G,"href","#how-does-a-transformer-work"),l(S,"class","relative group"),Gt(Ee.src,Ta="https://huggingface.co/datasets/huggingface-course/documentation-images/resolve/main/en/chapter1/transformers.svg")||l(Ee,"src",Ta),l(Ee,"alt","Original transformer architecture"),l(ne,"class","flex justify-center"),l(z,"id","using-transformers-for-audio"),l(z,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(z,"href","#using-transformers-for-audio"),l(A,"class","relative group"),Gt(Se.src,Ea="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/transformers_blocks.png")||l(Se,"src",Ea),l(Se,"alt","The transformer with audio input and output"),l(he,"class","flex justify-center"),l(V,"id","model-inputs"),l(V,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(V,"href","#model-inputs"),l(q,"class","relative group"),l(j,"id","text-input"),l(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(j,"href","#text-input"),l(P,"class","relative group"),l(U,"id","waveform-input"),l(U,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(U,"href","#waveform-input"),l(N,"class","relative group"),l(He,"href","../chapter1/introduction"),Gt(Me.src,$a="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/wav2vec2-input.png")||l(Me,"src",$a),l(Me,"alt","Wav2Vec2 uses a CNN to create embeddings from the input waveform"),l(ce,"class","flex justify-center"),l(D,"id","spectrogram-input"),l(D,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(D,"href","#spectrogram-input"),l(I,"class","relative group"),Gt(Fe.src,xa="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/whisper-input.png")||l(Fe,"src",xa),l(Fe,"alt","Whisper uses a CNN to create embeddings from the input spectrogram"),l(me,"class","flex justify-center"),l(J,"id","model-outputs"),l(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(J,"href","#model-outputs"),l(H,"class","relative group"),l(K,"id","text-output"),l(K,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(K,"href","#text-output"),l(M,"class","relative group"),l(Q,"id","spectrogram-output"),l(Q,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(Q,"href","#spectrogram-output"),l(O,"class","relative group"),Gt(Ce.src,Sa="https://huggingface.co/datasets/huggingface-course/audio-course-images/resolve/main/speecht5.png")||l(Ce,"src",Sa),l(Ce,"alt","SpeechT5 outputs a spectrogram and uses a vocoder to create the waveform"),l(ye,"class","flex justify-center"),l(ee,"id","waveform-output"),l(ee,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(ee,"href","#waveform-output"),l(R,"class","relative group"),l(te,"id","conclusion"),l(te,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),l(te,"href","#conclusion"),l(F,"class","relative group")},m(e,i){o(document.head,c),n(e,E,i),n(e,T,i),o(T,L),o(L,Je),v(ae,Je,null),o(T,Ko),o(T,Ke),o(Ke,Qo),n(e,Ct,i),n(e,W,i),o(W,Xo),o(W,se),o(se,Zo),o(W,er),n(e,zt,i),n(e,S,i),o(S,G),o(G,Qe),v(ie,Qe,null),o(S,tr),o(S,Xe),o(Xe,or),n(e,Vt,i),n(e,Te,i),o(Te,rr),n(e,jt,i),n(e,ne,i),o(ne,Ee),n(e,Ut,i),n(e,$,i),o($,ar),o($,Ze),o(Ze,sr),o($,ir),o($,et),o(et,nr),o($,lr),n(e,Dt,i),n(e,B,i),o(B,tt),o(tt,ot),o(ot,hr),o(B,ur),o(B,rt),o(rt,at),o(at,fr),n(e,Yt,i),n(e,$e,i),o($e,pr),n(e,Jt,i),n(e,C,i),o(C,cr),o(C,st),o(st,dr),o(C,mr),n(e,Kt,i),n(e,A,i),o(A,z),o(z,it),v(le,it,null),o(A,vr),o(A,nt),o(nt,wr),n(e,Qt,i),n(e,xe,i),o(xe,gr),n(e,Xt,i),n(e,he,i),o(he,Se),n(e,Zt,i),n(e,Ae,i),o(Ae,yr),n(e,eo,i),n(e,b,i),o(b,lt),o(lt,ht),o(ht,br),o(b,_r),o(b,ut),o(ut,ft),o(ft,kr),o(b,Tr),o(b,pt),o(pt,ct),o(ct,Er),o(b,$r),o(b,dt),o(dt,mt),o(mt,xr),n(e,to,i),n(e,qe,i),o(qe,Sr),n(e,oo,i),n(e,q,i),o(q,V),o(V,vt),v(ue,vt,null),o(q,Ar),o(q,wt),o(wt,qr),n(e,ro,i),n(e,Pe,i),o(Pe,Pr),n(e,ao,i),n(e,P,i),o(P,j),o(j,gt),v(fe,gt,null),o(P,Nr),o(P,yt),o(yt,Ir),n(e,so,i),n(e,Ne,i),o(Ne,Hr),n(e,io,i),n(e,N,i),o(N,U),o(U,bt),v(pe,bt,null),o(N,Mr),o(N,_t),o(_t,Or),n(e,no,i),n(e,Ie,i),o(Ie,Rr),n(e,lo,i),n(e,_,i),o(_,Fr),o(_,kt),o(kt,Lr),o(_,Wr),o(_,Tt),o(Tt,Gr),o(_,Br),o(_,He),o(He,Cr),o(_,zr),n(e,ho,i),n(e,ce,i),o(ce,Me),n(e,uo,i),n(e,Oe,i),o(Oe,Vr),n(e,fo,i),n(e,I,i),o(I,D),o(D,Et),v(de,Et,null),o(I,jr),o(I,$t),o($t,Ur),n(e,po,i),n(e,Y,i),o(Y,Dr),o(Y,xt),o(xt,Yr),o(Y,Jr),n(e,co,i),n(e,Re,i),o(Re,Kr),n(e,mo,i),n(e,me,i),o(me,Fe),n(e,vo,i),n(e,x,i),o(x,Qr),o(x,St),o(St,Xr),o(x,Zr),o(x,At),o(At,ea),o(x,ta),n(e,wo,i),n(e,Le,i),o(Le,oa),n(e,go,i),n(e,H,i),o(H,J),o(J,qt),v(ve,qt,null),o(H,ra),o(H,Pt),o(Pt,aa),n(e,yo,i),n(e,We,i),o(We,sa),n(e,bo,i),n(e,M,i),o(M,K),o(K,Nt),v(we,Nt,null),o(M,ia),o(M,It),o(It,na),n(e,_o,i),n(e,Ge,i),o(Ge,la),n(e,ko,i),n(e,O,i),o(O,Q),o(Q,Ht),v(ge,Ht,null),o(O,ha),o(O,Mt),o(Mt,ua),n(e,To,i),n(e,Be,i),o(Be,fa),n(e,Eo,i),n(e,X,i),o(X,pa),o(X,Ot),o(Ot,ca),o(X,da),n(e,$o,i),n(e,ye,i),o(ye,Ce),n(e,xo,i),v(Z,e,i),n(e,So,i),n(e,R,i),o(R,ee),o(ee,Rt),v(be,Rt,null),o(R,ma),o(R,Ft),o(Ft,va),n(e,Ao,i),n(e,ze,i),o(ze,wa),n(e,qo,i),n(e,F,i),o(F,te),o(te,Lt),v(_e,Lt,null),o(F,ga),o(F,Wt),o(Wt,ya),n(e,Po,i),n(e,Ve,i),o(Ve,ba),n(e,No,i),n(e,je,i),o(je,_a),n(e,Io,i),n(e,Ue,i),o(Ue,ka),Ho=!0},p(e,[i]){const ke={};i&2&&(ke.$$scope={dirty:i,ctx:e}),Z.$set(ke)},i(e){Ho||(w(ae.$$.fragment,e),w(ie.$$.fragment,e),w(le.$$.fragment,e),w(ue.$$.fragment,e),w(fe.$$.fragment,e),w(pe.$$.fragment,e),w(de.$$.fragment,e),w(ve.$$.fragment,e),w(we.$$.fragment,e),w(ge.$$.fragment,e),w(Z.$$.fragment,e),w(be.$$.fragment,e),w(_e.$$.fragment,e),Ho=!0)},o(e){g(ae.$$.fragment,e),g(ie.$$.fragment,e),g(le.$$.fragment,e),g(ue.$$.fragment,e),g(fe.$$.fragment,e),g(pe.$$.fragment,e),g(de.$$.fragment,e),g(ve.$$.fragment,e),g(we.$$.fragment,e),g(ge.$$.fragment,e),g(Z.$$.fragment,e),g(be.$$.fragment,e),g(_e.$$.fragment,e),Ho=!1},d(e){t(c),e&&t(E),e&&t(T),y(ae),e&&t(Ct),e&&t(W),e&&t(zt),e&&t(S),y(ie),e&&t(Vt),e&&t(Te),e&&t(jt),e&&t(ne),e&&t(Ut),e&&t($),e&&t(Dt),e&&t(B),e&&t(Yt),e&&t($e),e&&t(Jt),e&&t(C),e&&t(Kt),e&&t(A),y(le),e&&t(Qt),e&&t(xe),e&&t(Xt),e&&t(he),e&&t(Zt),e&&t(Ae),e&&t(eo),e&&t(b),e&&t(to),e&&t(qe),e&&t(oo),e&&t(q),y(ue),e&&t(ro),e&&t(Pe),e&&t(ao),e&&t(P),y(fe),e&&t(so),e&&t(Ne),e&&t(io),e&&t(N),y(pe),e&&t(no),e&&t(Ie),e&&t(lo),e&&t(_),e&&t(ho),e&&t(ce),e&&t(uo),e&&t(Oe),e&&t(fo),e&&t(I),y(de),e&&t(po),e&&t(Y),e&&t(co),e&&t(Re),e&&t(mo),e&&t(me),e&&t(vo),e&&t(x),e&&t(wo),e&&t(Le),e&&t(go),e&&t(H),y(ve),e&&t(yo),e&&t(We),e&&t(bo),e&&t(M),y(we),e&&t(_o),e&&t(Ge),e&&t(ko),e&&t(O),y(ge),e&&t(To),e&&t(Be),e&&t(Eo),e&&t(X),e&&t($o),e&&t(ye),e&&t(xo),y(Z,e),e&&t(So),e&&t(R),y(be),e&&t(Ao),e&&t(ze),e&&t(qo),e&&t(F),y(_e),e&&t(Po),e&&t(Ve),e&&t(No),e&&t(je),e&&t(Io),e&&t(Ue)}}}const ui={local:"unit-3-transformer-architectures-for-audio",sections:[{local:"how-does-a-transformer-work",title:"How does a transformer work?"},{local:"using-transformers-for-audio",title:"Using transformers for audio"},{local:"model-inputs",sections:[{local:"text-input",title:"Text input"},{local:"waveform-input",title:"Waveform input"},{local:"spectrogram-input",title:"Spectrogram input"}],title:"Model inputs"},{local:"model-outputs",sections:[{local:"text-output",title:"Text output"},{local:"spectrogram-output",title:"Spectrogram output"},{local:"waveform-output",title:"Waveform output"}],title:"Model outputs"},{local:"conclusion",title:"Conclusion"}],title:"Unit 3. Transformer architectures for audio"};function fi(Bt){return ii(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class mi extends oi{constructor(c){super();ri(this,c,fi,hi,ai,{})}}export{mi as default,ui as metadata};
